//------------------------------------------------------------------------------------------------------------------------------------
// PREF LIST WITH DESCRIPTIONS
//------------------------------------------------------------------------------------------------------------------------------------
// PREF									|Default| Desc
//--------------------------------------+-------+-------------------------------------------------------------------------------------
// $Pref::SwolDowned_CmdTick			|    38 | Do not change this, just for debugging
// $Pref::SwolDowned_DownedTime			| 11000 | Amount of time while downed before you die (granted you are full health)
// $Pref::SwolDowned_DownedBleedMult	|	0.2 | Every sequential downing makes the next downing n percent faster (20% by default)
// $Pref::SwolDowned_KillToLive			|  true | Can get second wind from killing players
// $Pref::SwolDowned_KillBotToLive		| false | Can get second wind from killing bots
// $Pref::SwolDowned_DownedPerLife		|	  1 | How many times you can be downed per life before you just die (-1 for infinite)
// $Pref::SwolDowned_CanHelpUp			|     1 | Can people help other people up by clicking on them?
// $Pref::SwolDowned_HelpUpTime			|  6000 | How long does it take to help someone up
// $Pref::SwolDowned_DownedMessages		| true  | Show messages when an ally gets downed (or anyone if no teams)
// $Pref::SwolDowned_HelpUpMessages		| true	| Show messages when ally helps another ally up
// $Pref::SwolDowned_DownedNoDamage		| false | If downed players can take damage
// $Pref::SwolDowned_DownedNoItems		| false | If downed players can use weapons
// $Pref::SwolDowned_RevengeMode		| false | Revives all downed players if the person who downed them dies
//										|		|
// $Pref::SwolDowned_Reset				| false | Set this to true and restart server to reset all prefs to default
//--------------------------------------+-------+-------------------------------------------------------------------------------------
//
// EXTENDED DOWNED DB
// use these commands to add datablocks for playertypes that have different models, keep in mind this adds to the datablock count
//------------------------------------------------------------------------------------------------------------------------------------
// downed_addExtDb(DBNAME);		Add a db to the list
// downed_remExtDb(DBNAME);		Remove a db from the list
// downed_listExtDb();			List all the ext db
// downed_clearExtDb();			Clear all the ext db
//
//------------------------------------------------------------------------------------------------------------------------------------
// Type these in the console to set prefs, prefs take effect instantly and stay persistent
// Example: 
//   $Pref::SwolDowned_KillToLive = false;
//   $Pref::SwolDowned_DownedTime = 5000;
//   $Pref::SwolDowned_DownedPerLife = -1;
//------------------------------------------------------------------------------------------------------------------------------------
// Thank you for downloading!
//   ~love Swollow (6531)


//--------------Datablocks----------------------------------------------------
datablock PlayerData(PlayerDowned : PlayerStandardArmor)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	firstPersonOnly = 1;
	jumpForce = 0;
	jumpSound = "";
	
	runForce = 1900;
	maxBackwardspeed = 0;
	maxForwardSpeed = 0;
	maxSideSpeed = 0;
	maxBackwardCrouchSpeed = 0.7;
	maxForwardCrouchSpeed = 1;
	maxSideCrouchSpeed = 0.7;
	uiName = "";
	isDowned = 1;
};
datablock AudioProfile(downed_heartBeatSound)
{
	filename    = "./heartBeat.wav";
	description = Audio2d;
	preload = true;
};
//--------------Support Functions----------------------------------------------------
function downed_clearExtDb()
{
	for(%i=0;%i<$Pref::SwolDowned_ExtDbCnt;%i++)
		$Pref::SwolDowned_ExtDb[%i] = "";
	$Pref::SwolDowned_ExtDbCnt = "";
	echo("\c1Server_Downed EXT DB | Cleared All");
}
function downed_listExtDb()
{
	echo("\c1Server_Downed EXT DB | List");
	for(%i=0;%i<$Pref::SwolDowned_ExtDbCnt;%i++)
	{
		echo(" \c1" @ $Pref::SwolDowned_ExtDb[%i]);
	}
	if($Pref::SwolDowned_ExtDbCnt == 0)
		echo("\c1No DB in list");
}
function downed_remExtDb(%id)
{
	if(isObject(%id))
		%id = %id.getName();
	%pass = false;
	for(%i=0;%i<$Pref::SwolDowned_ExtDbCnt;%i++)
	{
		if($Pref::SwolDowned_ExtDb[%i] $= %id)
		{
			$Pref::SwolDowned_ExtDb[%i] = "";
			%pass = true;
		}
	}
	if(%pass)
	{
		%cnt = $Pref::SwolDowned_ExtDbCnt;
		for(%i=0;%i<%cnt;%i++)
		{
			if($Pref::SwolDowned_ExtDb[%i] $= "")
			{
				for(%a=%i+1;%a<$Pref::SwolDowned_ExtDbCnt;%a++)
					$Pref::SwolDowned_ExtDb[%a-1] = $Pref::SwolDowned_ExtDb[%a];
				$Pref::SwolDowned_ExtDb[%a-1] = "";
				%cnt--;
			}
		}
		$Pref::SwolDowned_ExtDbCnt = %cnt;
	}
	if(%pass)
		echo("\c1Server_Downed EXT DB | Removed: " @ %id);
	else
		echo("\c1Server_Downed EXT DB | DB not in list");
}
function downed_addExtDb(%id)
{
	if(!isObject(%id))
		return echo("\c2Server_Downed EXT DB | Error: Object does not exist!");
	if(%id.getClassName() !$= "PlayerData")
		return echo("\c2Server_Downed EXT DB | Error: Invalid object");
	%id = %id.getName();
	for(%i=0;%i<$Pref::SwolDowned_ExtDbCnt;%i++)
		if($Pref::SwolDowned_ExtDb[%i] $= %id)
			return echo("\c2Server_Downed EXT DB | Error: DB already in list");

	$Pref::SwolDowned_ExtDbCnt = mFloor($Pref::SwolDowned_ExtDbCnt);
	$Pref::SwolDowned_ExtDb[$Pref::SwolDowned_ExtDbCnt] = %id;
	$Pref::SwolDowned_ExtDbCnt++;
	echo("\c1Server_Downed EXT DB | ADDED: " @ %id);
	echo(" \c1Server restart required to take effect");
}
function downed_iniExtDownedDb()
{
	for(%i=0;%i<$Pref::SwolDowned_ExtDbCnt;%i++)
	{
		if(isObject(%n = $Pref::SwolDowned_ExtDb[%i]))
		{
			if(%n.getClassName() $= "PlayerData")
			{
				%n = %n.getName();
				eval("datablock PlayerData(PlayerDowned_" @ %n @ ":PlayerDowned){shapeFile=\"" @ %n.shapeFile @ "\";};");
				echo("\c1Server_Downed EXT DB | INI: " @ %n);
			}
		}
	}
}
function downed_hasDownedDb(%id)
{
	if(fileBase(%id.shapeFile) $= "m")
		return 1;
	%id = %id.getName();
	if(isObject("PlayerDowned_" @ %id))
		return 1;
}
function rgbToHex( %rgb )
{
	%r = _compToHex( 255 * getWord( %rgb, 0 ) );
	%g = _compToHex( 255 * getWord( %rgb, 1 ) );
	%b = _compToHex( 255 * getWord( %rgb, 2 ) );

	return %r @ %g @ %b;
}
function _compToHex( %comp )
{
	%left = mFloor( %comp / 16 );
	%comp = mFloor( %comp - %left * 16 );

	%left = getSubStr( "0123456789ABCDEF", %left, 1 );
	%comp = getSubStr( "0123456789ABCDEF", %comp, 1 );

	return %left @ %comp;
}
function rgbGradient(%step, %c1, %c2)
{
	%r1 = getWord(%c1, 0);
	%g1 = getWord(%c1, 1);
	%b1 = getWord(%c1, 2);

	%r2 = getWord(%c2, 0);
	%g2 = getWord(%c2, 1);
	%b2 = getWord(%c2, 2);

	%r3 = %r1 + %step * (%r2 - %r1);
	%g3 = %g1 + %step * (%g2 - %g1);
	%b3 = %b1 + %step * (%b2 - %b1);

	return %r3 SPC %g3 SPC %b3;
}
if($Pref::SwolDowned_Reset){$Pref::SwolDowned_CmdTick=$Pref::SwolDowned_DownedTime=$Pref::SwolDowned_DownedBleedMult=$Pref::SwolDowned_KillToLive=$Pref::SwolDowned_KillBotToLive=$Pref::SwolDowned_DownedPerLife=$Pref::SwolDowned_CanHelpUp=$Pref::SwolDowned_HelpUpTime=$Pref::SwolDowned_DownedMessages=$Pref::SwolDowned_DownedMessages=$Pref::SwolDowned_HelpUpMessages=$Pref::SwolDowned_DownedNoDamage=$Pref::SwolDowned_DownedNoItems=$Pref::SwolDowned_RevengeMode="";if($Pref::SwolDowned_ExtDbCnt > 0)downed_clearExtDb();$Pref::SwolDowned_Reset = 0;}
if($Pref::SwolDowned_CmdTick $= "")$Pref::SwolDowned_CmdTick = 38;
if($Pref::SwolDowned_DownedTime $= "")$Pref::SwolDowned_DownedTime = 11000;
if($Pref::SwolDowned_DownedBleedMult $= "")$Pref::SwolDowned_DownedBleedMult = 0.2;
if($Pref::SwolDowned_KillToLive $= "")$Pref::SwolDowned_KillToLive = 1;
if($Pref::SwolDowned_KillBotToLive $= "")$Pref::SwolDowned_KillBotToLive = 0;
if($Pref::SwolDowned_DownedPerLife $= "")$Pref::SwolDowned_DownedPerLife = 1;
if($Pref::SwolDowned_CanHelpUp $= "")$Pref::SwolDowned_CanHelpUp = 1;
if($Pref::SwolDowned_HelpUpTime $= "")$Pref::SwolDowned_HelpUpTime = 6000;
if($Pref::SwolDowned_DownedMessages $= "")$Pref::SwolDowned_DownedMessages = 1;
if($Pref::SwolDowned_HelpUpMessages $= "")$Pref::SwolDowned_HelpUpMessages = 1;
if($Pref::SwolDowned_DownedNoDamage $= "")$Pref::SwolDowned_DownedNoDamage = 0;
if($Pref::SwolDowned_DownedNoItems $= "")$Pref::SwolDowned_DownedNoItems = 0;
if($Pref::SwolDowned_RevengeMode $= "")$Pref::SwolDowned_RevengeMode = 0;
if($Pref::SwolDowned_ExtDbCnt > 0)downed_iniExtDownedDb();

function gameConnection::downed_secondWindAnim(%cl,%tick,%str)
{
	//Makes an animated more impactful center print animated message
	%size = mClamp(62*mSin((%tick/25)*$PI),2,80);
	centerPrint(%cl,"<br><br><br><br><br><br><font:impact:" @ %size @ "><color:" @ rgbToHex(rgbGradient(%tick/18,"1 1 1","1 0.8 0")) @ ">" @ %str @ "!",3);
	if(%tick > 17)
		return;
	%cl.downed_secondWindAnimSched = %cl.schedule(30,downed_secondWindAnim,%tick++,%str);
}
function player::downed_kill(%pl)
{
	cancel(%pl.downed_killSched);
	if(getSimTime()-%pl.lastPushTime > 1000 && isObject(%pl.downed_lastPusher))
	{
		%pl.lastPushTime = getSimTime();
		%pl.lastPusher = %pl.downed_lastPusher;
	}
	%pl.downedKill = 1;
	%pl.damage(%pl.downed_killer,%pl.getPosition(),999999,%pl.downed_dmgType);
}
function player::setDowned(%pl,%bool)
{
	if(%pl.isDowned != %bool)
	{
		%pl.isDowned = %bool;
		%set = $Swol_DownedSimSet;
		if(%bool)
		{
			if(!%pl.getDatablock().isDowned) //Hold datablock before setting to downed
				%pl.downed_Db = %pl.getDatablock();
			if(isObject(%t = "PlayerDowned_" @ %pl.getDatablock().getName()))
				%pl.setDatablock(%t);
			else
				%pl.setDatablock(playerDowned);
			
			if($Pref::SwolDowned_DownedNoItems)
			{
				if(isObject(%pl.client))
					serverCmdUnUseTool(%pl.client);
				%pl.unMountImage(0);
			}
			%set.add(%pl);
			%pl.setHealth(1);
			%pl.setDamageFlash(0.8);
			%pl.downed_psuedoHealth = %pl.getDatablock().maxDamage-1; //Use pseudo health to avoid damage flash flickers every tick
			%pl.downed_heartBeatTick = getSimTime();
			%pl.downed_downedTime = getSimTime();
			%pl.downed_healthSapTime = getSimTime();
			%pl.downed_doSitAnimTrig = 0;
			%pl.downed_deathTime = $Pref::SwolDowned_DownedTime-(($Pref::SwolDowned_DownedTime*$Pref::SwolDowned_DownedBleedMult)*%pl.downed_times);
			%pl.downed_times++;
			if(isObject(%m = (%vic = %pl.client).minigame) && $Pref::SwolDowned_DownedMessages)
			{
				%mode = "default"; //broadcast message to everyone
				if(%m.class $= "Slayer_MinigameSO") //support for slayer
					%mode = "slayer";
				else if(($Swol_SpaceGuyTdm||($Swol_SpaceGuyTdm=(isFunction(gameModeAttribute)&&isFunction(gameModeTitleToID))))&&(%id=gameModeTitleToID(%m.gamemode))!=-1&&gameModeAttribute(%id,"UsesTeams"))
					%mode = "tdm";//Support for space guy's TDM
				
				%msg = "<color:ffffaa>" @ %vic.getPlayerName() @ "\c3 has been downed!";
				for(%i=0;%i<%m.numMembers;%i++)
				{
					%cl = %m.member[%i];
					switch$(%mode)
					{
						case "default":
							messageClient(%cl,'',%msg);
						case "slayer":
							if(%cl.getTeam() == %vic.getTeam())
								messageClient(%cl,'',%msg);
						case "tdm":
							if(%cl.tdmTeam == %vic.tdmTeam)
								messageClient(%cl,'',%msg);
					}
				}
			}
			if(!isEventPending(%set.sched))
				swol_downedLoop();
		}
		else
		{
			if(isObject(%pl.downed_Db))
				%pl.setDatablock(%pl.downed_Db);
			%pl.downed_Db = "";
			if(%set.isMember(%pl))
				%set.remove(%pl);
			%pl.setActionThread(root,1);
			%pl.playThread(0,root);
			%pl.setHealth(%pl.getDatablock().maxDamage);
			if(isObject(%cl = %pl.client))
				commandToClient(%cl,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor);
		}
	}
}
function swol_downedLoop()
{
	%set = $Swol_DownedSimSet;
	if(!(%cnt = %set.getCount()))
		return;
	cancel(%set.sched);
	for(%i=0;%i<%cnt;%i++)
	{
		%pl = %set.getObject(%i);
		if(isObject(%cl = %pl.client))
		{
			if(getSimTime()-%pl.downed_lastCmdTick > $Pref::SwolDowned_CmdTick) //Don't need to run this super fast for any reason
			{
				if(%pl.downed_psuedoHealth == 0)
				{
					if(getSimTime()-%pl.downed_helpUpTime > 150) //If you are being helped up don't kill
					{
						%pl.downed_kill();
						return;
					}
				}
				else if(getSimTime()-%pl.downed_healthSapTime > %pl.downed_deathTime/100) //Can we get another full heart beat effect before the player dies?
				{
					%pl.downed_evadeDamageFlash = 1;
					%pl.damage(%pl,%pl.getPosition(),(%pl.getDatablock().maxDamage/100),$DamageType::Suicide);
					%pl.downed_evadeDamageFlash = 0;
					%pl.downed_healthSapTime = getSimTime();
				}
				%heartBeatMax = mClamp(((%pl.downed_psuedoHealth*2)/100)*1200,450,1200); //Speed up heart rate as time goes on
				if((%pl.downed_deathTime/100)*%pl.downed_psuedoHealth > %heartBeatMax)
				{
					if(getSimTime()-%pl.downed_heartBeatTick > %heartBeatMax)
					{
						%cl.play2d(downed_heartBeatSound);
						%pl.downed_heartBeatTick = getSimTime();
					}
					%cont = true;
				}
				//Fade the screen in red as you hit the end of your time
				if((%t = ((%pl.downed_deathTime/100)*%pl.downed_psuedoHealth)) < 2400)
					%pl.setDamageFlash((1-((%t*0.9)/2400))+(getSimTime()-(%pl.downed_downedTime < 3400 ? (getSimTime()-%pl.downed_downedTime)/3400 : 0)*0.8));
				//Smooth heart beats
				%alpha = mClampF(mSin(($PI*(1-(getSimTime()-%pl.downed_heartBeatTick)/%heartBeatMax))),0,1);
				if(!%cont && %alpha > %pl.downed_lastAlpha) //Safety protection
					%alpha = %pl.downed_lastAlpha;
				%pl.downed_lastAlpha = %alpha;
				%vigAlpha = mClampF(getWord($EnvGuiServer::VignetteColor,3),0,1);
				%fAlpha = mClampF(%alpha,(%cont ? mClampF(%vigAlpha,0,0.2) : %vigAlpha),1); //Try to blend heart beats with default vignette best as possible while still looking good
				commandToClient(%cl,'setVignette',$EnvGuiServer::VignetteMultiply,rgbGradient(1-%alpha,"1 0 0",$EnvGuiServer::VignetteColor) SPC %fAlpha);
				%pl.downed_lastCmdTick = getSimTime();
			}
			if(getSimTime()-%pl.downed_helpUpTime > 90)
			{
				centerPrint(%cl,"<br><br><br><br><br><br><font:impact:38><color:ff7777>You are downed" @ (($Pref::SwolDowned_KillToLive || $Pref::SwolDowned_KillBotToLive) && !$Pref::SwolDowned_DownedNoItems ? "<br><font:impact:24>" @ ((getSimTime()-%pl.downed_downedTime)%500 > 250 ? "<color:ff3333>" : "\c6") @ "Fight for your life" : ($Pref::SwolDowned_CanHelpUp ? "<br><font:impact:24>\c6Wait for a teammate to help you up" : "")),1);
			}
		}
		//This is why we have this hacky 1ms loop for downed players
		if(!%pl.isCrouched())
		{
			//Force the player into a sitting position if they aren't crawling, as long as we do this on 350ms frame intervals you will only see weird effects
			//if the player mashes their keys and manages to stand up for a fraction of a second on these small 1ms frame windows
			if(getSimTime()-%pl.downed_doSitAnim > 350)
			{
				//%pl.setActionThread(sit,1);
				if(!%pl.downed_doSitAnimTrig)
				{
					%pl.playThread(0,sit);
					%pl.downed_doSitAnimTrig = 1;
					%pl.setActionThread(root,1);
				}
				%pl.downed_doSitAnim = getSimTime();
			}
			%pl.downed_forceCrouch = 1;
		}
		else if(%pl.downed_forceCrouch)
		{
			%pl.playThread(0,root);
			%pl.downed_doSitAnim = 0;
			%pl.setActionThread(crouch,1);
			%pl.downed_forceCrouch = 0;
		}
	}
	%set.sched = schedule(1,0,swol_downedLoop);
}
function player::downed_helpUp(%pl,%bool)
{
	cancel(%pl.downed_clickLoop);
	if(%pl.isDowned)
	{
		if(%pl.downed_armReady)
			%bool = 0;
		else
			return;
	}
	if(%bool)
	{
		cancel(%pl.downed_clickLoop);
		%eye = vectorScale(%pl.getEyeVector(),8);
		%pos = %pl.getEyePoint();
		%hit = getWord(containerRaycast(%pos,vectorAdd(%pos,%eye),$TypeMasks::PlayerObjectType,%pl),0);
		if(isObject(%hit))
		{
			if(isObject(%pl.client))
				%name = "<color:ffffaa>" @ %pl.client.getPlayerName();
			else if(%pl.isHoleBot)
				%name = "A bot";
			else
				%name = "A player";
			
			if(!%pl.downed_helpUp && %hit.isDowned)
			{
				if(isObject(%hit.client))
				{
					if(%hit.client.minigame == (%m = %pl.client.minigame))
					{
						if(%m.class $= "Slayer_MinigameSO")
						{ //Slayer support, dont help other teams!
							if(%hit.client.getTeam() != %pl.client.getTeam())
								return;
						}
						else if(($Swol_SpaceGuyTdm||($Swol_SpaceGuyTdm=(isFunction(gameModeAttribute)&&isFunction(gameModeTitleToID))))&&(%id=gameModeTitleToID(%m.gamemode))!=-1&&gameModeAttribute(%id,"UsesTeams"))
						{ //Support for space guy's TDM from 7 years ago (compatibility is always good!)
							if(%hit.client.tdmTeam != %pl.client.tdmTeam)
								return;
						}
					}
				}
				%pl.playThread(2,armReadyRight);
				%pl.downed_armReady = true;
				%pl.downed_helpUp = %hit;
			}
			else if(%pl.downed_helpUp != %hit) //If the help-upper looks away towards another player who also happens to be downed...
			{
				%pl.downed_helpUp(0);
				return;
			}
			else
			{
				%pl.downed_helpUpProg++;
				if(%pl.downed_helpUpProg > $Pref::SwolDowned_HelpUpTime/80)
				{
					%hit.setDowned(0);
					%pl.downed_helpUp(0);
					%hit.emote(loveImage,1);
					
					if($Pref::SwolDowned_HelpUpMessages && isObject(%hit.client))
					{
						%m = %pl.client.minigame;
						%mode = "default"; //broadcast message to everyone
						if(%m.class $= "Slayer_MinigameSO") //support for slayer
							%mode = "slayer";
						else if(($Swol_SpaceGuyTdm||($Swol_SpaceGuyTdm=(isFunction(gameModeAttribute)&&isFunction(gameModeTitleToID))))&&(%id=gameModeTitleToID(%m.gamemode))!=-1&&gameModeAttribute(%id,"UsesTeams"))
							%mode = "tdm";//Support for space guy's TDM
						
						%vic = %hit.client;
						%msg = "\c3" @ %name @ "\c3 helped <color:ffffaa>" @ %vic.getPlayerName() @ "\c3 up";
						for(%i=0;%i<%m.numMembers;%i++)
						{
							%cl = %m.member[%i];
							switch$(%mode)
							{
								case "default":
									messageClient(%cl,'',%msg);
								case "slayer":
									if(%cl.getTeam() == %vic.getTeam())
										messageClient(%cl,'',%msg);
								case "tdm":
									if(%cl.tdmTeam == %vic.tdmTeam)
										messageClient(%cl,'',%msg);
							}
						}
					}
					centerPrint(%pl.client,"",1);
					centerPrint(%hit.client,"<br><br><br><br><br><br><font:impact:24>" @ %name @ "\c6 helped you up!",3);
					return;
				}
			}
			//Basically just a ton of code for formatting the progress bar and messages when helping someone up
			%prcnt = %pl.downed_helpUpProg/($Pref::SwolDowned_HelpUpTime/80);
			%max = 30;
			%fill = mFloor(%prcnt*%max);
			%col = rgbGradient(%prcnt,"1 0.6 0.6","0.6 1 0.6");
			%hex = rgbToHex(%col);
			%bars = "<font:impact:14><color:" @ %hex @ ">";
			for(%i=0;%i<%fill;%i++)
				%bars = %bars @ "|";
			%bars = %bars @ "\c6";
			for(%i=0;%i<%max-%fill;%i++)
				%bars = %bars @ "|";
			
			if(isObject(%hit.client))
				%nameVic = "<color:ffffaa>" @ %hit.client.getPlayerName();
			else if(%hit.isHoleBot)
				%nameVic = "a bot";
			else
				%nameVic = "a player";
			%hit.downed_helpUpTime = getSimTime();
			centerPrint(%pl.client,"<br><br><br><br><br><br><font:impact:24>\c6Helping up " @ %nameVic @ "<br>" @ %bars,1);
			centerPrint(%hit.client,"<br><br><br><br><br><br><font:impact:24>" @ %name @ "\c6 is helping you up<br>" @ %bars,1);
			
			%pl.downed_clickLoop = %pl.schedule(80,downed_helpUp,%bool);
		}
		else //Look away
		{
			%pl.downed_helpUp(0);
		}
	}
	else
	{
		centerPrint(%pl.client,"",1);
		if(%pl.downed_armReady)
		{
			%pl.playThread(2,root);
			%pl.downed_armReady = false;
		}
		%pl.downed_helpUp = 0;
		%pl.downed_helpUpProg = 0;
	}
}
function gameConnection::downed_backUp(%cl,%check,%revenge,%by)
{
	//hacky little check for second wind to reduce code usage
	if(!isObject(%pl = %cl.player))
		return;
	if(%check.getState() $= "Dead")
	{
		if($Pref::SwolDowned_HelpUpMessages)
		{
			%m = %cl.minigame;
			%mode = "default"; //broadcast message to everyone
			if(%m.class $= "Slayer_MinigameSO") //support for slayer
				%mode = "slayer";
			else if(($Swol_SpaceGuyTdm||($Swol_SpaceGuyTdm=(isFunction(gameModeAttribute)&&isFunction(gameModeTitleToID))))&&(%id=gameModeTitleToID(%m.gamemode))!=-1&&gameModeAttribute(%id,"UsesTeams"))
				%mode = "tdm";//Support for space guy's TDM
			
			%msg = "<color:ffffaa>" @ %cl.getPlayerName() @ "\c3 is back up!";
			for(%i=0;%i<%m.numMembers;%i++)
			{
				%vic = %m.member[%i];
				switch$(%mode)
				{
					case "default":
						messageClient(%vic,'',%msg);
					case "slayer":
						if(%cl.getTeam() == %vic.getTeam())
							messageClient(%vic,'',%msg);
					case "tdm":
						if(%cl.tdmTeam == %vic.tdmTeam)
							messageClient(%vic,'',%msg);
				}
			}
		}
		%cl.downed_backUp = getSimTime();
		%pl.setDowned(0);
		%cl.downed_secondWindAnim(0,(%revenge ? (%by $= "" ? "Revenge" : "Avenged by " @ %by) : "Second Wind"));
	}
}
package swol_downed
{
	function armor::onTrigger(%db,%pl,%trig,%bool)
	{
		if($Pref::SwolDowned_CanHelpUp && (%set = $Swol_DownedSimSet).getCount() > 0)
		{
			if(%pl.getMountedImage(0) == 0 && %trig == 0)
			{
				if(%bool == true)
				{
					if(getSimTime()-%pl.downed_lastHelpUpAttempt < 850)
						return parent::onTrigger(%db,%pl,%trig,%bool);
					%pl.downed_lastHelpUpAttempt = getSimTime();
				}
				%pl.downed_helpUp(%bool);
			}
		}
		return parent::onTrigger(%db,%pl,%trig,%bool);
	}
	function serverCmdUseTool(%cl,%i)
	{
		if(!isObject(%pl = %cl.player))
			return parent::serverCmdUseTool(%cl,%i);
		if(%pl.isDowned && $Pref::SwolDowned_DownedNoItems)
			return;
		return parent::serverCmdUseTool(%cl,%i);
	}
	function armor::damage(%db,%pl,%hit,%pos,%dmg,%dmgType)
	{
		if(%pl.isDowned)
		{
			if(%pl.downed_psuedoHealth > 0)
			{
				if(!%pl.downed_evadeDamageFlash)
				{
					if($Pref::SwolDowned_DownedNoDamage)
						return;
					if((%pl.downed_deathTime/100)*%pl.downed_psuedoHealth > 2400) //use psuedo health to prevent damageFlash flickering every tick
						%pl.setDamageFlash(mClampF(%dmg,0,100)/100);
				}
				
				if(%dmg < %pl.downed_psuedoHealth)
				{
					%pl.downed_psuedoHealth -= %dmg;
					%dmg = 0;
				}
				else if(%dmg >= %pl.downed_psuedoHealth)
				{
					%dmg -= %pl.downed_psuedoHealth;
					%pl.downed_psuedoHealth = 0;
				}
			}
		}
		if($Pref::SwolDowned_RevengeMode)
		{
			if(isObject(%hit.player))
				%atk = %hit.player;
			else if(isObject(%hit.client))
				%atk = %hit.client.player;
			if(isObject(%atk) && %atk != %pl && %atk != %pl.client)
			{
				if(isFunction(%atk,"getPlayerName"))
					%name = %atk.getPlayerName();
				else if(%atk.isHoleBot)
					%name = "a bot";
				else
					%name = "a player";
			}
			for(%i=0;%i<%pl.downed_downedVictimCnt;%i++)
			{
				if(!isObject(%pl.downed_downedVictim[%i]))
					continue;
				if(%pl.downed_downedVictim[%i].getState() $= "Dead")
					continue;
				if(%pl.downed_downedVictim[%i].isDowned)
				{
					if(isObject(%pl.downed_downedVictim[%i].client))
					{
						%pl.downed_downedVictim[%i].client.schedule(5,downed_backUp,%pl,1,(%atk != %pl.downed_downedVictim[%i] && %atk != %pl.downed_downedVictim[%i].client ? %name : ""));
					}
				}
			}
		}
		if(($Pref::SwolDowned_KillToLive && %pl.getClassName() $= "Player") || ($Pref::SwolDowned_KillBotToLive && %pl.getClassName() $= "AiPlayer"))
		{
			if(isObject(%hit.player))
				%atk = %hit.player;
			else if(isObject(%hit.client))
				%atk = %hit.client.player;
			
			if(isObject(%atk))
			{
				if(%atk.isDowned)
				{
					if(isObject(%atk.client))
					{
						%atk.client.schedule(5,downed_backUp,%pl);
					}
				}
			}
		}
		if(!isObject(%pl.client.minigame))
			return parent::damage(%db,%pl,%hit,%pos,%dmg,%dmgType);
		if(getSimTime()-%pl.downed_downedTime < 500)
			return;
		if(%pl.isDowned) //Give kill credit for finish off kills if the downed commits suicide or bleeds out
		{
			if(isObject(%pl.downed_killer) && (!(%hit == %pl.client || %hit.client == %pl.client) || (!isObject(%hit) && !isObject(%hit.client))))
			{
				if(isObject(%pl.downed_killer))
				{
					%hit = %pl.downed_killer;
				}
			}
		}
		if(($Pref::SwolDowned_DownedPerLife == -1 || (%pl.downed_times < $Pref::SwolDowned_DownedPerLife)) && %pl.getClassName() !$= "AiPlayer")
		{
			if(!%pl.isDowned && !%pl.downedKill && %pl.getDamageLevel()+%dmg >= (%db = %pl.getDatablock()).maxDamage && !%db.disableDowned && strPos($Pref::SwolDowned_DatablocksDisabled,%db.getName()) == -1)
			{
				if(downed_hasDownedDb(%pl.getDatablock().getName()))
				{
					if($Pref::SwolDowned_RevengeMode)
					{
						if(isObject(%hit.player))
							%atk = %hit.player;
						else if(isObject(%hit.client))
							%atk = %hit.client.player;
							
						%atk.downed_downedVictim[mFloor(%atk.downed_downedVictimCnt)] = %pl;
						%atk.downed_downedVictimCnt++;
					}
					%pl.downed_killer = (!isObject(%hit.client) ? %hit : %hit.client);
					%pl.downed_dmgType = %dmgType;
					%pl.setDowned(1);
					return;
				}
			}
		}
		if(%dmg == 0)
			return;
		return parent::damage(%db,%pl,%hit,%pos,%dmg,%dmgType);
	}
	function gameConnection::onDeath(%cl,%killer,%killerPl,%dmgType,%dmgLoc)
	{
		if(isObject(%plTmp = %cl.player))
			if(%plTmp.isDowned)
				commandToClient(%cl,'setVignette',$EnvGuiServer::VignetteMultiply,$EnvGuiServer::VignetteColor); //idk why this kind of stuff isn't default
		return parent::onDeath(%cl,%killer,%killerPl,%dmgType,%dmgLoc);
	}
};
activatePackage(swol_downed);
if(!isObject($Swol_DownedSimSet))
{
	$Swol_DownedSimSet = new simSet();
	missionCleanup.add($Swol_DownedSimSet);
}

//Some fixes to prevent overlapping messages with my killsteak mod
if(isFile("Add-Ons/Server_Killstreaks_and_Dominations.zip") && $AddOn__Server_Killstreaks_and_Dominations == 1)
	ForceRequiredAddon("Server_Killstreaks_and_Dominations");
else
	return;
if(!isPackage(swol_ks))
	return;

package swol_downed_overrides
{
	function gameConnection::swol_displayKillstreak(%cl,%kills,%multiKills,%points)
	{
		if(getSimTime()-%cl.downed_backUp < 2500)
		{
			%cl.schedule(2500-(getSimTime()-%cl.downed_backUp),swol_displayKillstreak,%kills,%multiKills,%points);
			return;
		}
		return parent::swol_displayKillstreak(%cl,%kills,%multiKills,%points);
	}
	function gameConnection::swol_domination(%cl,%killer,%killed,%mode)
	{
		if(getSimTime()-%cl.downed_backUp < 2500)
		{
			%cl.schedule(2500-(getSimTime()-%cl.downed_backUp),swol_domination,%killer,%killed,%mode);
			return;
		}
		return parent::swol_domination(%cl,%killer,%killed,%mode);
	}
};
activatePackage(swol_downed_overrides);